# $Revision: 1.25 $, $Date: 2002/07/28 23:21:01 $
Summary:	32-bit compiler for the i386 and m68k processors
Summary(pl):	32 bitowy kompilator dla procesorw i386 i m68k
Name:		fpc
Version:	1.0.4
Release:	3
License:	GPL
Group:		Development/Languages
Vendor:		Michael Van Canneyt <michael@tfdec1.fys.kuleuven.ac.be>
Source0:	ftp://ftp.freepascal.org/pub/fpc/dist/Linux/%{name}-%{version}.ELF.tar
Source1:	%{name}-sample.cfg
Patch0:		%{name}-poptasm.patch
Patch1:		%{name}-glibc.patch
URL:		http://www.freepascal.org/
Requires:	gcc >= 2.95.2
BuildRequires:	bin86
BuildRequires:	glibc-static
BuildRequires:	zlib-devel
ExclusiveArch:	%{ix86} m68k
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Free Pascal is a 32-bit compiler for the i386 and m68k processors.
Free Pascal is designed to be, as much as possible, source compatible
with Turbo Pascal 7.0 and Delphi 4 (although this goal is not yet
attained), but it also enhances these languages with elements like
function overloading. And, unlike these ancestors, it supports
multiple platforms.

%description -l pl
Free Pascal to 32 bitowy kompilator dla procesorw i386 oraz m86k.
Free Pascal zosta zaprojektowany by by (jak tylko to moliwe)
kompatybilnym z Turbo Pascal 7.0 oraz Delphi 4. Free Pascal rwnie
rozszerza te jzyki elementami takimi jak przeadowywanie funkcji.

%package examples
Summary:	Free Pascal Compiler exaple programs
Summary(pl):	Przykadowe programy do kompilatora Free Pascal
Group:		Documentation
Requires:	%{name} = %{version}

%description examples
Free Pascal Compiler exaple programs.

%description examples -l pl
Przykadowe programy do kompilatora Free Pascal.

%package doc
Summary:	Free Pascal Compiler documentation
Summary(pl):	Dokumentacja do kompilatora Free Pascal
Group:		Documentation
Requires:	%{name} = %{version}

%description doc
Documentation for fpc in PDF format.

%description doc -l pl
Dokumentacja do fpc w formacie PDF.

%prep
%setup -q -c
tar xf sources.tar
tar xf binary.tar

for i in *.tar.gz ; do
	tar xzf $i
done

mkdir -p src/%{name}-%{version}/doc
mv doc/%{name}-%{version}/* src/%{name}-%{version}/doc
mkdir -p src/%{name}-%{version}/man && echo ".PHONY:	all install installman" > src/%{name}-%{version}/man/Makefile

cd src/%{name}-%{version}
%patch0 -p0
%patch1 -p0

%build
if [ "%{_build_cpu}" = "m68k" ]; then
	CPU=M68K
else
	CPU=I386
fi

# DO NOT PUT $RPM_OPT_FLAGS IN OPT, IT DOES NOT WORK - baggins
case "%{_build_cpu}" in
	i386)
		OPTF="-OG2p1" ;;
	i586)
		OPTF="-OG2p2" ;;
	i686)
		OPTF="-Og2p3" ;;
	*)
		OPTF="-O2" ;;
esac

PP=`pwd`/lib/fpc/%{version}/ppc386
NEWPP=`pwd`/src/fpc-%{version}/compiler/ppc386

# -O- optimalization to workaround bug in PP compiler in 1.0.4
%{__make} -C src/%{name}-%{version} \
	OPT="-O- -Xs -n" \
	RELEASE="" \
	BASEINSTALLDIR=%{_libdir}/%{name}/%{version} \
	BININSTALLDIR=%{_bindir} \
	PP="$PP" \
	FPC="$PP" \
	compiler_cycle

%{__make} -C src/%{name}-%{version} \
	OPT="$OPTF -Xs -n" \
	RELEASE="" \
	BASEINSTALLDIR=%{_libdir}/%{name}/%{version} \
	BININSTALLDIR=%{_bindir} \
	PP="$NEWPP" \
	FPC="$NEWPP" \
	rtl_all api_all fcl_all packages_all utils_all

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir},%{_mandir},%{_examplesdir}/fpc}

install %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/ppc386.cfg

# workaround for 1.0.4
(cd src/fpc-%{version}; ln -s fcl/linux linux)

NEWPP=`pwd`/src/fpc-%{version}/compiler/ppc386
%{__make} -C src/%{name}-%{version} \
	PREFIXINSTALLDIR=$RPM_BUILD_ROOT%{_prefix} \
	PP="$NEWPP" \
	compiler_install \
	rtl_install api_install fcl_install packages_install utils_install

cp -a man/* $RPM_BUILD_ROOT%{_mandir}
cp -a src/%{name}-%{version}/doc/examples/* $RPM_BUILD_ROOT%{_examplesdir}/fpc

ln -sf ../lib/%{name}/%{version}/ppc386 $RPM_BUILD_ROOT%{_bindir}/ppc386
ln -sf ppc386 $RPM_BUILD_ROOT%{_bindir}/fpc

mv -f src/%{name}-%{version}/doc/faq.htm src/%{name}-%{version}/doc/faq.html

%clean
rm -rf $RPM_BUILD_ROOT

%post
umask 022
GCCSPEC=`(gcc -v 2>&1)| head -n 1| awk '{ print $4 } '`
GCCDIR=`dirname $GCCSPEC`
echo "Found libgcc.a in $GCCDIR"
sed -e "s#\$GCCDIR#$GCCDIR#" %{_sysconfdir}/ppc386.cfg > %{_sysconfdir}/ppc386.cfg.new
sed -e "s#\$1#%{_libdir}/%{name}/%{version}#" %{_sysconfdir}/ppc386.cfg.new > %{_sysconfdir}/ppc386.cfg
rm -f %{_sysconfdir}/ppc386.cfg.new

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/*
%doc src/%{name}-%{version}/doc/{copying*,*.txt}
%doc src/%{name}-%{version}/doc/faq.html
%config %verify(not md5 size mtime) %{_sysconfdir}/ppc386.cfg
%dir %{_libdir}/%{name}
%dir %{_libdir}/%{name}/%{version}
%dir %{_libdir}/%{name}/lexyacc
%{_libdir}/%{name}/%{version}/msg
%{_libdir}/%{name}/%{version}/units
%{_libdir}/%{name}/lexyacc/*
%attr(755,root,root) %{_libdir}/%{name}/%{version}/ppc386
%attr(755,root,root) %{_libdir}/%{name}/%{version}/samplecfg
%{_mandir}/man*/*

%files examples
%defattr(644,root,root,755)
%doc %{_examplesdir}/fpc

%files doc
%defattr(644,root,root,755)
%doc src/%{name}-%{version}/doc/*.pdf

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld.org.pl>
All persons listed below can be reached at <cvs_login>@pld.org.pl

$Log: fpc.spec,v $
Revision 1.25  2002/07/28 23:21:01  ankry
- new %%doc
- release 3

Revision 1.24  2002/05/14 14:05:24  qboosh
- Patch1 itself requires glibc-static

Revision 1.23  2002/04/25 16:19:24  arturs
fixed a small typo

Revision 1.22  2002/04/09 15:14:39  arekmat
- BR: zlib-devel

NOTE: It doesn't build without glibc-static (patch1 doesn't work), please
someone correct this (I don't know how).

Revision 1.21  2002/02/23 02:06:14  kloczek
- adapterized.

Revision 1.20  2002/02/22 23:28:54  kloczek
- removed all Group fields translations (our rpm now can handle translating
  Group field using gettext).

Revision 1.19  2002/01/30 18:38:13  alchemyx
- ugly words back again. sorry.

Revision 1.18  2002/01/29 02:55:46  alchemyx
- ugly words replaced with "?" ;-)

Revision 1.17  2002/01/18 02:12:58  kloczek
perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.16  2001/12/12 21:01:43  qrczak
- fpc-glibc.patch: Workaround for newer versions of glibc. For a reason
  unknown to me symbols __libc_init and __setfpucw are available only
  in the static version of libc. This fixes linking bin2obj. It should
  be possible to do it better, this is a hack.
- Release 2.

Revision 1.15  2001/11/26 16:00:36  qboosh
- adapterized

Revision 1.14  2001/10/23 15:04:06  undefine
- link from ppc386 to fpc (look at man)

Revision 1.13  2001/08/23 16:51:22  filon
- changed: make -> %%{__make}

Revision 1.12  2001/01/13 16:42:17  misiek
1.0.4 release

Revision 1.11  2000/12/06 18:11:36  kloczek
- do not compress man pages.

Revision 1.10  2000/12/06 17:19:14  undefine
- updated to 1.0.2

Revision 1.9  2000/09/19 14:57:45  zagrodzki
- release 2
- use new built compiler

Revision 1.8  2000/09/14 15:04:26  baggins
- rewrite, works now
- I don't know what was here, but it was _not_ spec for fpc

Revision 1.7  2000/09/12 10:21:51  baggins
- update to 1.00
- started fixing (misiek, you screwed this spec!!!)

Revision 1.6  2000/06/09 07:22:50  kloczek
- added using %%{__make} macro.

Revision 1.5  2000/05/18 21:48:35  kloczek
- spec adapterized.

Revision 1.4  2000/04/01 11:14:26  zagrodzki
- changed all BuildRoot definitons
- removed all applnkdir defs
- changed some prereqs/requires
- removed duplicate empty lines

Revision 1.3  2000/03/28 16:54:17  baggins
- translated kloczkish into english

Revision 1.2  2000/02/28 13:14:14  misiek
- adaptized and updated

Revision 1.1  2000/02/28 12:54:28  misiek
- Free Pascal Compilator
